Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6639)
@@ -3569,6 +4975,529 @@
 !!          CALL iom_put(TRIM(ctrc3d(5)), trc3d(:,:,:,5))
 !! #  endif
-# endif
-      ENDIF ! end of ln_diatrc option
+
+
+      ELSE IF( lk_iomput .AND. .NOT. ln_diatrc ) THEN
+         !!!----------------------------------------------------------------------
+         !! Add very last diag calculations 
+         !!!----------------------------------------------------------------------
+         DO jj = 2,jpjm1
+            DO ji = 2,jpim1
+                !!         
+                IF( med_diag%PN_JLIM%dgsave ) THEN
+                    fjln2d(ji,jj) = fjln2d(ji,jj)  / MAX(ftot_pn(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PN_NLIM%dgsave ) THEN
+                    fnln2d(ji,jj) = fnln2d(ji,jj)  / MAX(ftot_pn(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PN_FELIM%dgsave ) THEN
+                    ffln2d(ji,jj) = ffln2d(ji,jj)  / MAX(ftot_pn(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PD_JLIM%dgsave ) THEN
+                    fjld2d(ji,jj) = fjld2d(ji,jj)  / MAX(ftot_pd(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PD_NLIM%dgsave ) THEN
+                    fnld2d(ji,jj) = fnld2d(ji,jj)  / MAX(ftot_pd(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PD_FELIM%dgsave ) THEN
+                    ffld2d(ji,jj) = ffld2d(ji,jj)  / MAX(ftot_pd(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PD_SILIM%dgsave ) THEN
+                    fsld2d2(ji,jj) = fsld2d2(ji,jj)  / MAX(ftot_pd(ji,jj), rsmall)
+                ENDIF
+                IF( med_diag%PDSILIM2%dgsave ) THEN
+                    fsld2d(ji,jj) = fsld2d(ji,jj)  / MAX(ftot_pd(ji,jj), rsmall)
+                ENDIF
+            ENDDO
+         ENDDO
+         !!----------------------------------------------------------------------
+         !! Add in XML diagnostics stuff
+         !!----------------------------------------------------------------------
+         !!
+         !! ** 2D diagnostics
+#   if defined key_debug_medusa
+         IF (lwp) write (numout,*) 'trc_bio_medusa: export all diag.'
+         CALL flush(numout)
+#   endif
+         IF ( med_diag%INVTN%dgsave ) THEN
+             CALL iom_put( "INVTN"  , ftot_n )
+         ENDIF
+         IF ( med_diag%INVTSI%dgsave ) THEN
+             CALL iom_put( "INVTSI"  , ftot_si )
+         ENDIF
+         IF ( med_diag%INVTFE%dgsave ) THEN
+             CALL iom_put( "INVTFE"  , ftot_fe )
+         ENDIF                           
+         IF ( med_diag%ML_PRN%dgsave ) THEN
+             CALL iom_put( "ML_PRN"  , fprn_ml )
+         ENDIF
+         IF ( med_diag%ML_PRD%dgsave ) THEN
+             CALL iom_put( "ML_PRD"  , fprd_ml )
+         ENDIF
+         IF ( med_diag%OCAL_LVL%dgsave ) THEN
+             CALL iom_put( "OCAL_LVL"  , fccd )
+         ENDIF
+         IF ( med_diag%PN_JLIM%dgsave ) THEN
+             CALL iom_put( "PN_JLIM"  , fjln2d )
+             CALL wrk_dealloc( jpi, jpj,   fjln2d   )
+         ENDIF
+         IF ( med_diag%PN_NLIM%dgsave ) THEN
+             CALL iom_put( "PN_NLIM"  , fnln2d )
+             CALL wrk_dealloc( jpi, jpj,   fnln2d   )
+         ENDIF
+         IF ( med_diag%PN_FELIM%dgsave ) THEN
+             CALL iom_put( "PN_FELIM"  , ffln2d )
+             CALL wrk_dealloc( jpi, jpj,   ffln2d   )
+         ENDIF
+         IF ( med_diag%PD_JLIM%dgsave ) THEN
+             CALL iom_put( "PD_JLIM"  , fjld2d )
+             CALL wrk_dealloc( jpi, jpj,  fjld2d    )
+         ENDIF
+         IF ( med_diag%PD_NLIM%dgsave ) THEN
+             CALL iom_put( "PD_NLIM"  , fnld2d )
+             CALL wrk_dealloc( jpi, jpj,   fnld2d  )
+         ENDIF
+         IF ( med_diag%PD_FELIM%dgsave ) THEN
+             CALL iom_put( "PD_FELIM"  , ffld2d )
+             CALL wrk_dealloc( jpi, jpj,  ffld2d    )
+         ENDIF
+         IF ( med_diag%PD_SILIM%dgsave ) THEN
+             CALL iom_put( "PD_SILIM"  , fsld2d2 )
+             CALL wrk_dealloc( jpi, jpj,   fsld2d2   )
+         ENDIF
+         IF ( med_diag%PDSILIM2%dgsave ) THEN
+             CALL iom_put( "PDSILIM2"  , fsld2d )
+             CALL wrk_dealloc( jpi, jpj,   fsld2d   )
+         ENDIF
+         IF ( med_diag%INTFLX_N%dgsave ) THEN
+             CALL iom_put( "INTFLX_N"  , fflx_n )
+         ENDIF
+         IF ( med_diag%INTFLX_SI%dgsave ) THEN
+             CALL iom_put( "INTFLX_SI"  , fflx_si )
+         ENDIF
+         IF ( med_diag%INTFLX_FE%dgsave ) THEN
+             CALL iom_put( "INTFLX_FE"  , fflx_fe )
+         ENDIF        
+         IF ( med_diag%INT_PN%dgsave ) THEN
+             CALL iom_put( "INT_PN"  , ftot_pn )
+         ENDIF
+         IF ( med_diag%INT_PD%dgsave ) THEN
+             CALL iom_put( "INT_PD"  , ftot_pd )
+         ENDIF         
+         IF ( med_diag%INT_ZMI%dgsave ) THEN
+             CALL iom_put( "INT_ZMI"  , ftot_zmi )
+         ENDIF
+         IF ( med_diag%INT_ZME%dgsave ) THEN
+             CALL iom_put( "INT_ZME"  , ftot_zme )
+         ENDIF
+         IF ( med_diag%INT_DET%dgsave ) THEN
+             CALL iom_put( "INT_DET"  , ftot_det )
+         ENDIF
+         IF ( med_diag%INT_DTC%dgsave ) THEN
+             CALL iom_put( "INT_DTC"  , ftot_dtc )
+         ENDIF
+         IF ( med_diag%BEN_N%dgsave ) THEN
+             CALL iom_put( "BEN_N"  , za_sed_n )
+         ENDIF
+         IF ( med_diag%BEN_FE%dgsave ) THEN
+             CALL iom_put( "BEN_FE"  , za_sed_fe )
+         ENDIF
+         IF ( med_diag%BEN_C%dgsave ) THEN
+             CALL iom_put( "BEN_C"  , za_sed_c )
+         ENDIF
+         IF ( med_diag%BEN_SI%dgsave ) THEN
+             CALL iom_put( "BEN_SI"  , za_sed_si )
+         ENDIF
+         IF ( med_diag%BEN_CA%dgsave ) THEN
+             CALL iom_put( "BEN_CA"  , za_sed_ca )
+         ENDIF
+         IF ( med_diag%RUNOFF%dgsave ) THEN
+             CALL iom_put( "RUNOFF"  , f_runoff )
+         ENDIF 
+# if defined key_roam        
+         IF ( med_diag%N_PROD%dgsave ) THEN
+             CALL iom_put( "N_PROD"  , fnit_prod )
+         ENDIF
+         IF ( med_diag%N_CONS%dgsave ) THEN
+             CALL iom_put( "N_CONS"  , fnit_cons )
+         ENDIF
+         IF ( med_diag%C_PROD%dgsave ) THEN
+             CALL iom_put( "C_PROD"  , fcar_prod )
+         ENDIF
+         IF ( med_diag%C_CONS%dgsave ) THEN
+             CALL iom_put( "C_CONS"  , fcar_cons )
+         ENDIF
+         IF ( med_diag%O2_PROD%dgsave ) THEN
+             CALL iom_put( "O2_PROD"  , foxy_prod )
+         ENDIF
+         IF ( med_diag%O2_CONS%dgsave ) THEN
+             CALL iom_put( "O2_CONS"  , foxy_cons )
+         ENDIF
+         IF ( med_diag%O2_ANOX%dgsave ) THEN
+             CALL iom_put( "O2_ANOX"  , foxy_anox )
+         ENDIF
+         IF ( med_diag%INVTC%dgsave ) THEN
+             CALL iom_put( "INVTC"  , ftot_c )
+         ENDIF
+         IF ( med_diag%INVTALK%dgsave ) THEN
+             CALL iom_put( "INVTALK"  , ftot_a )
+         ENDIF
+         IF ( med_diag%INVTO2%dgsave ) THEN
+            CALL iom_put( "INVTO2"  , ftot_o2 )
+         ENDIF
+         IF ( med_diag%COM_RESP%dgsave ) THEN
+             CALL iom_put( "COM_RESP"  , fcomm_resp )
+         ENDIF         
+# endif      
+         !!
+         !! diagnostic filled in the i-j-k main loop
+         !!--------------------------------------------
+        IF ( med_diag%PRN%dgsave ) THEN
+            CALL iom_put( "PRN"  , fprn2d )
+            CALL wrk_dealloc( jpi, jpj,   fprn2d   )
+        ENDIF
+        IF ( med_diag%MPN%dgsave ) THEN
+            CALL iom_put( "MPN"  ,fdpn2d  )
+            CALL wrk_dealloc( jpi, jpj,    fdpn2d  )
+        ENDIF
+        IF ( med_diag%PRD%dgsave ) THEN
+            CALL iom_put( "PRD"  ,fprd2d  )
+            CALL wrk_dealloc( jpi, jpj,   fprd2d  )
+        ENDIF
+        IF( med_diag%MPD%dgsave ) THEN
+            CALL iom_put( "MPD"  , fdpd2d )
+            CALL wrk_dealloc( jpi, jpj,    fdpd2d )
+        ENDIF
+        !  IF( med_diag%DSED%dgsave ) THEN
+        !      CALL iom_put( "DSED"  , ftot_n )
+        !  ENDIF
+        IF( med_diag%OPAL%dgsave ) THEN
+            CALL iom_put( "OPAL"  , fprds2d )
+            CALL wrk_dealloc( jpi, jpj,   fprds2d  )
+        ENDIF
+        IF( med_diag%OPALDISS%dgsave ) THEN
+            CALL iom_put( "OPALDISS"  , fsdiss2d )
+            CALL wrk_dealloc( jpi, jpj,   fsdiss2d  )
+        ENDIF
+        IF( med_diag%GMIPn%dgsave ) THEN
+            CALL iom_put( "GMIPn"  , fgmipn2d )
+            CALL wrk_dealloc( jpi, jpj,   fgmipn2d  )
+        ENDIF
+        IF( med_diag%GMID%dgsave ) THEN
+            CALL iom_put( "GMID"  , fgmid2d )
+            CALL wrk_dealloc( jpi, jpj,  fgmid2d  )
+        ENDIF
+        IF( med_diag%MZMI%dgsave ) THEN
+            CALL iom_put( "MZMI"  , fdzmi2d )
+            CALL wrk_dealloc( jpi, jpj,   fdzmi2d   )
+        ENDIF
+        IF( med_diag%GMEPN%dgsave ) THEN
+            CALL iom_put( "GMEPN"  , fgmepn2d )
+            CALL wrk_dealloc( jpi, jpj,   fgmepn2d  )
+        ENDIF
+        IF( med_diag%GMEPD%dgsave ) THEN
+            CALL iom_put( "GMEPD"  , fgmepd2d )
+            CALL wrk_dealloc( jpi, jpj,   fgmepd2d   )
+        ENDIF
+        IF( med_diag%GMEZMI%dgsave ) THEN
+            CALL iom_put( "GMEZMI"  , fgmezmi2d )
+            CALL wrk_dealloc( jpi, jpj,   fgmezmi2d   )
+        ENDIF
+        IF( med_diag%GMED%dgsave ) THEN
+            CALL iom_put( "GMED"  , fgmed2d )
+            CALL wrk_dealloc( jpi, jpj,    fgmed2d  )
+        ENDIF
+        IF( med_diag%MZME%dgsave ) THEN
+            CALL iom_put( "MZME"  , fdzme2d )
+            CALL wrk_dealloc( jpi, jpj,  fdzme2d    )
+        ENDIF
+        !  IF( med_diag%DEXP%dgsave ) THEN
+        !      CALL iom_put( "DEXP"  , ftot_n )
+        !  ENDIF
+        IF( med_diag%DETN%dgsave ) THEN
+            CALL iom_put( "DETN"  , fslown2d )
+            CALL wrk_dealloc( jpi, jpj,  fslown2d    )
+        ENDIF
+        IF( med_diag%MDET%dgsave ) THEN
+            CALL iom_put( "MDET"  , fdd2d )
+            CALL wrk_dealloc( jpi, jpj,   fdd2d   )
+        ENDIF
+        IF( med_diag%AEOLIAN%dgsave ) THEN
+            CALL iom_put( "AEOLIAN"  , ffetop2d )
+            CALL wrk_dealloc( jpi, jpj,   ffetop2d   )
+        ENDIF
+        IF( med_diag%BENTHIC%dgsave ) THEN
+            CALL iom_put( "BENTHIC"  , ffebot2d )
+            CALL wrk_dealloc( jpi, jpj,   ffebot2d   )
+        ENDIF
+        IF( med_diag%SCAVENGE%dgsave ) THEN
+            CALL iom_put( "SCAVENGE"  , ffescav2d )
+            CALL wrk_dealloc( jpi, jpj,   ffescav2d  )
+        ENDIF
+        !! 
+        IF( med_diag%TOTREG_N%dgsave ) THEN
+            CALL iom_put( "TOTREG_N"  , fregen2d )
+            CALL wrk_dealloc( jpi, jpj,   fregen2d   )
+        ENDIF
+        IF( med_diag%TOTRG_SI%dgsave ) THEN
+            CALL iom_put( "TOTRG_SI"  , fregensi2d )
+            CALL wrk_dealloc( jpi, jpj,    fregensi2d  )
+        ENDIF
+        !! 
+        IF( med_diag%FASTN%dgsave ) THEN
+            CALL iom_put( "FASTN"  , ftempn2d )
+            CALL wrk_dealloc( jpi, jpj,   ftempn2d   )
+        ENDIF
+        IF( med_diag%FASTSI%dgsave ) THEN
+            CALL iom_put( "FASTSI"  , ftempsi2d )
+            CALL wrk_dealloc( jpi, jpj,   ftempsi2d   )
+        ENDIF
+        IF( med_diag%FASTFE%dgsave ) THEN
+            CALL iom_put( "FASTFE"  , ftempfe2d )
+            CALL wrk_dealloc( jpi, jpj,    ftempfe2d  )
+        ENDIF
+        IF( med_diag%FASTC%dgsave ) THEN
+            CALL iom_put( "FASTC"  , ftempc2d )
+            CALL wrk_dealloc( jpi, jpj,  ftempc2d    )
+        ENDIF
+        IF( med_diag%FASTCA%dgsave ) THEN
+            CALL iom_put( "FASTCA"  , ftempca2d )
+           CALL wrk_dealloc( jpi, jpj,  ftempca2d   )
+        ENDIF
+        !! 
+        IF( med_diag%REMINN%dgsave ) THEN
+            CALL iom_put( "REMINN"  , freminn2d )
+            CALL wrk_dealloc( jpi, jpj,   freminn2d   )
+        ENDIF
+        IF( med_diag%REMINSI%dgsave ) THEN
+            CALL iom_put( "REMINSI"  , freminsi2d )
+            CALL wrk_dealloc( jpi, jpj,   freminsi2d   )
+        ENDIF
+        IF( med_diag%REMINFE%dgsave ) THEN
+            CALL iom_put( "REMINFE"  , freminfe2d )
+            CALL wrk_dealloc( jpi, jpj,  freminfe2d    )
+        ENDIF
+        IF( med_diag%REMINC%dgsave ) THEN
+            CALL iom_put( "REMINC"  , freminc2d )
+            CALL wrk_dealloc( jpi, jpj,    freminc2d  )
+        ENDIF
+        IF( med_diag%REMINCA%dgsave ) THEN
+            CALL iom_put( "REMINCA"  , freminca2d )
+             CALL wrk_dealloc( jpi, jpj,   freminca2d  )
+        ENDIF
+        IF( med_diag%SEAFLRN%dgsave ) THEN
+            CALL iom_put( "SEAFLRN"  , fsedn )
+        ENDIF
+        IF( med_diag%SEAFLRSI%dgsave ) THEN
+            CALL iom_put( "SEAFLRSI"  , fsedsi )
+        ENDIF
+        IF( med_diag%SEAFLRFE%dgsave ) THEN
+            CALL iom_put( "SEAFLRFE"  , fsedfe )
+        ENDIF
+        IF( med_diag%SEAFLRC%dgsave ) THEN
+            CALL iom_put( "SEAFLRC"  , fsedc )
+        ENDIF
+        IF( med_diag%SEAFLRCA%dgsave ) THEN
+            CALL iom_put( "SEAFLRCA"  , fsedca )
+        ENDIF
+
+        !!
+        !!
+        !!
+        !!  
+        !! 
+        !!
+        !! 
+        !!
+        !!
+# if defined key_roam            
+        !!
+        !!
+        IF( med_diag%RIV_N%dgsave ) THEN
+            CALL iom_put( "RIV_N"  , rivn2d )
+             CALL wrk_dealloc( jpi, jpj,    rivn2d  )
+        ENDIF
+        IF( med_diag%RIV_SI%dgsave ) THEN
+            CALL iom_put( "RIV_SI"  , rivsi2d )
+             CALL wrk_dealloc( jpi, jpj,   rivsi2d   )
+        ENDIF
+        IF( med_diag%RIV_C%dgsave ) THEN
+            CALL iom_put( "RIV_C"  , rivc2d )
+             CALL wrk_dealloc( jpi, jpj,    rivc2d  )
+        ENDIF
+        IF( med_diag%RIV_ALK%dgsave ) THEN
+            CALL iom_put( "RIV_ALK"  , rivalk2d )
+             CALL wrk_dealloc( jpi, jpj,  rivalk2d    )
+        ENDIF
+        IF( med_diag%DETC%dgsave ) THEN
+            CALL iom_put( "DETC"  , fslowc2d )
+             CALL wrk_dealloc( jpi, jpj,   fslowc2d   )
+        ENDIF
+        !! 
+        !!              
+        !!
+        IF( med_diag%PN_LLOSS%dgsave ) THEN
+            CALL iom_put( "PN_LLOSS"  , fdpn22d )
+             CALL wrk_dealloc( jpi, jpj,   fdpn22d   )
+        ENDIF
+        IF( med_diag%PD_LLOSS%dgsave ) THEN
+            CALL iom_put( "PD_LLOSS"  , fdpd22d )
+             CALL wrk_dealloc( jpi, jpj,   fdpd22d   )
+        ENDIF
+        IF( med_diag%ZI_LLOSS%dgsave ) THEN
+            CALL iom_put( "ZI_LLOSS"  , fdzmi22d )
+             CALL wrk_dealloc( jpi, jpj,    fdzmi22d  )
+        ENDIF
+        IF( med_diag%ZE_LLOSS%dgsave ) THEN
+            CALL iom_put( "ZE_LLOSS"  , fdzme22d )
+             CALL wrk_dealloc( jpi, jpj,   fdzme22d   )
+        ENDIF
+        IF( med_diag%ZI_MES_N%dgsave ) THEN
+            CALL iom_put( "ZI_MES_N"  , zimesn2d )
+             CALL wrk_dealloc( jpi, jpj,    zimesn2d  )
+        ENDIF
+        IF( med_diag%ZI_MES_D%dgsave ) THEN
+            CALL iom_put( "ZI_MES_D"  , zimesd2d )
+             CALL wrk_dealloc( jpi, jpj,    zimesd2d  )
+        ENDIF
+        IF( med_diag%ZI_MES_C%dgsave ) THEN
+            CALL iom_put( "ZI_MES_C"  , zimesc2d )
+             CALL wrk_dealloc( jpi, jpj,    zimesc2d  )
+        ENDIF
+        IF( med_diag%ZI_MESDC%dgsave ) THEN
+            CALL iom_put( "ZI_MESDC"  ,zimesdc2d  )
+             CALL wrk_dealloc( jpi, jpj,    zimesdc2d  )
+        ENDIF
+        IF( med_diag%ZI_EXCR%dgsave ) THEN
+            CALL iom_put( "ZI_EXCR"  , ziexcr2d )
+             CALL wrk_dealloc( jpi, jpj,    ziexcr2d )
+        ENDIF
+        IF( med_diag%ZI_RESP%dgsave ) THEN
+            CALL iom_put( "ZI_RESP"  , ziresp2d )
+             CALL wrk_dealloc( jpi, jpj,   ziresp2d   )
+        ENDIF
+        IF( med_diag%ZI_GROW%dgsave ) THEN
+            CALL iom_put( "ZI_GROW"  , zigrow2d )
+             CALL wrk_dealloc( jpi, jpj,   zigrow2d   )
+        ENDIF
+        IF( med_diag%ZE_MES_N%dgsave ) THEN
+            CALL iom_put( "ZE_MES_N"  , zemesn2d )
+             CALL wrk_dealloc( jpi, jpj,    zemesn2d  )
+        ENDIF
+        IF( med_diag%ZE_MES_D%dgsave ) THEN
+            CALL iom_put( "ZE_MES_D"  , zemesd2d )
+             CALL wrk_dealloc( jpi, jpj,    zemesd2d  )
+        ENDIF
+        IF( med_diag%ZE_MES_C%dgsave ) THEN
+            CALL iom_put( "ZE_MES_C"  , zemesc2d )
+             CALL wrk_dealloc( jpi, jpj,   zemesc2d   )
+        ENDIF
+        IF( med_diag%ZE_MESDC%dgsave ) THEN
+            CALL iom_put( "ZE_MESDC"  , zemesdc2d )
+             CALL wrk_dealloc( jpi, jpj,   zemesdc2d   )
+        ENDIF
+        IF( med_diag%ZE_EXCR%dgsave ) THEN
+            CALL iom_put( "ZE_EXCR"  , zeexcr2d )
+             CALL wrk_dealloc( jpi, jpj,   zeexcr2d   )
+        ENDIF
+        IF( med_diag%ZE_RESP%dgsave ) THEN
+            CALL iom_put( "ZE_RESP"  , zeresp2d )
+             CALL wrk_dealloc( jpi, jpj,    zeresp2d  )
+        ENDIF
+        IF( med_diag%ZE_GROW%dgsave ) THEN
+            CALL iom_put( "ZE_GROW"  , zegrow2d )
+             CALL wrk_dealloc( jpi, jpj,   zegrow2d   )
+        ENDIF
+        IF( med_diag%MDETC%dgsave ) THEN
+            CALL iom_put( "MDETC"  , mdetc2d )
+             CALL wrk_dealloc( jpi, jpj,   mdetc2d   )
+        ENDIF
+        IF( med_diag%GMIDC%dgsave ) THEN
+            CALL iom_put( "GMIDC"  , gmidc2d )
+             CALL wrk_dealloc( jpi, jpj,    gmidc2d  )
+        ENDIF
+        IF( med_diag%GMEDC%dgsave ) THEN
+            CALL iom_put( "GMEDC"  , gmedc2d )
+             CALL wrk_dealloc( jpi, jpj,    gmedc2d  )
+        ENDIF
+        IF( med_diag%IBEN_N%dgsave ) THEN
+           CALL iom_put( "IBEN_N"  , iben_n2d )
+             CALL wrk_dealloc( jpi, jpj,    iben_n2d  )
+        ENDIF
+        IF( med_diag%IBEN_FE%dgsave ) THEN
+           CALL iom_put( "IBEN_FE"  , iben_fe2d )
+             CALL wrk_dealloc( jpi, jpj,   iben_fe2d   )
+        ENDIF
+        IF( med_diag%IBEN_C%dgsave ) THEN
+           CALL iom_put( "IBEN_C"  , iben_c2d )
+             CALL wrk_dealloc( jpi, jpj,   iben_c2d   )
+        ENDIF
+        IF( med_diag%IBEN_SI%dgsave ) THEN
+           CALL iom_put( "IBEN_SI"  , iben_si2d )
+             CALL wrk_dealloc( jpi, jpj,   iben_si2d   )
+        ENDIF
+        IF( med_diag%IBEN_CA%dgsave ) THEN
+           CALL iom_put( "IBEN_CA"  , iben_ca2d )
+             CALL wrk_dealloc( jpi, jpj,   iben_ca2d   )
+        ENDIF
+        IF( med_diag%OBEN_N%dgsave ) THEN
+           CALL iom_put( "OBEN_N"  , oben_n2d )
+             CALL wrk_dealloc( jpi, jpj,    oben_n2d  )
+        ENDIF
+        IF( med_diag%OBEN_FE%dgsave ) THEN
+           CALL iom_put( "OBEN_FE"  , oben_fe2d )
+             CALL wrk_dealloc( jpi, jpj,    oben_fe2d  )
+        ENDIF
+        IF( med_diag%OBEN_C%dgsave ) THEN
+           CALL iom_put( "OBEN_C"  , oben_c2d )
+             CALL wrk_dealloc( jpi, jpj,    oben_c2d  )
+        ENDIF
+        IF( med_diag%OBEN_SI%dgsave ) THEN
+           CALL iom_put( "OBEN_SI"  , oben_si2d )
+             CALL wrk_dealloc( jpi, jpj,    oben_si2d  )
+        ENDIF
+        IF( med_diag%OBEN_CA%dgsave ) THEN
+           CALL iom_put( "OBEN_CA"  , oben_ca2d )
+             CALL wrk_dealloc( jpi, jpj, oben_ca2d     )
+        ENDIF
+        IF( med_diag%SFR_OCAL%dgsave ) THEN
+           CALL iom_put( "SFR_OCAL"  , sfr_ocal2d )
+             CALL wrk_dealloc( jpi, jpj,    sfr_ocal2d  )
+        ENDIF
+        IF( med_diag%SFR_OARG%dgsave ) THEN
+           CALL iom_put( "SFR_OARG"  , sfr_oarg2d )
+             CALL wrk_dealloc( jpi, jpj,    sfr_oarg2d  )
+        ENDIF
+        IF( med_diag%LYSO_CA%dgsave ) THEN
+           CALL iom_put( "LYSO_CA"  , lyso_ca2d )
+             CALL wrk_dealloc( jpi, jpj,    lyso_ca2d  )
+        ENDIF
+# endif                   
+         !!          
+         !!
+         !! ** 3D diagnostics
+         IF( med_diag%TPP3%dgsave ) THEN
+             CALL iom_put( "TPP3"  , tpp3d )
+              CALL wrk_dealloc( jpi, jpj, jpk,   tpp3d  )
+         ENDIF
+         IF( med_diag%DETFLUX3%dgsave ) THEN
+             CALL iom_put( "DETFLUX3"  , detflux3d )
+              CALL wrk_dealloc( jpi, jpj, jpk,    detflux3d )
+         ENDIF
+          IF( med_diag%REMIN3N%dgsave ) THEN
+             CALL iom_put( "REMIN3N"  , remin3dn )
+             CALL wrk_dealloc( jpi, jpj, jpk,   remin3dn  )
+          ENDIF
+# if defined key_roam          
+          IF( med_diag%PH3%dgsave ) THEN
+              CALL iom_put( "PH3"  , f3_pH )
+          ENDIF
+          IF( med_diag%OM_CAL3%dgsave ) THEN
+              CALL iom_put( "OM_CAL3"  , f3_omcal )
+          ENDIF
+# endif         
+
+      CALL wrk_dealloc( jpi, jpj,   zw2d   )
+
+     ENDIF ! end of ln_diatrc option
 
 # if defined key_trc_diabio
@@ -3576,5 +5505,5 @@
       DO jn=1,jp_medusa_trd
           CALL lbc_lnk(trbio(:,:,1,jn),'T',1. )
-      END DO 
+      ENDDO 
 # endif
 
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90	(revision 6639)
@@ -47,5 +47,5 @@
 !=======================================================================
 !
-      SUBROUTINE trc_co2_medusa( Temp, Sal, DIC, ALK, Depth, Wnd, pCO2a, &
+      SUBROUTINE trc_co2_medusa( Temp, Sal, DIC, ALK, Depth, xkw, pCO2a, &
       pH, pCO2w, h2co3, hco3, co3, om_cal, om_arg, co2flux, TDIC, TALK,  &
       dcf, henry, iters )
@@ -72,4 +72,6 @@
 ! 17/02/2010. Update calculation of K1, K2, Kb to make consistant with the OCMIP protocols.
 ! 29/07/2011. Merged into MEDUSA with a raft of changes to this subroutine; less elsewhere
+! 23/06/2015. Modified to take gas transfer velocity as an input (rather than wind speed); 
+!             alter CO2 flux to /s rather than /d for consistency with other schemes
 !
 ! Changes for MEDUSA include: 
@@ -85,5 +87,6 @@
       REAL(wp), INTENT( in )    :: ALK        ! meq  / m3
       REAL(wp), INTENT( in )    :: Depth      ! m
-      REAL(wp), INTENT( in )    :: Wnd        ! m / s
+!     REAL(wp), INTENT( in )    :: Wnd        ! m / s
+      REAL(wp), INTENT( in )    :: xkw        ! m / s
       REAL(wp), INTENT( in )    :: pCO2a      ! uatm
 !----------------------------------------------------------------------
@@ -95,5 +98,5 @@
       REAL(wp), INTENT( inout ) :: om_cal     ! normalised
       REAL(wp), INTENT( inout ) :: om_arg     ! normalised
-      REAL(wp), INTENT( inout ) :: co2flux    ! mmol / m2 / d
+      REAL(wp), INTENT( inout ) :: co2flux    ! mmol / m2 / s
       REAL(wp), INTENT( inout ) :: TDIC       ! umol / kg
       REAL(wp), INTENT( inout ) :: TALK       ! ueq  / kg
@@ -129,5 +132,5 @@
    !                 (i.e. surface calculations being performed)
    if (Depth .eq. 0.0) then
-      call Air_sea_exchange( Temp, Wnd, pCO2w, pCO2a, henry, dcf, &         ! inputs
+      call Air_sea_exchange( Temp, xkw, pCO2w, pCO2a, henry, dcf, &         ! inputs
          co2flux )                                                          ! output
    else
@@ -145,5 +148,5 @@
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: zdic    =', DIC
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: zalk    =', ALK
-      IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_wind  =', Wnd
+      IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_kw660 =', xkw
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_ph    =', ph
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_pco2w =', pCO2w
@@ -162,5 +165,5 @@
       &        ' DIC', DIC, ' ALK', ALK
       if (lwp) write (numout,'(a,a,f10.3,a,f10.3)') 'CO2FLUX-NAN', &
-      &        ' WND', Wnd, ' PH ', ph
+      &        ' XKW', xkw, ' PH ', ph
       if (lwp) write (numout,'(a,a,i6)') 'CO2FLUX-NAN', &
       &        ' ITERS', iters
@@ -196,5 +199,5 @@
 !  WRITE(*,'(A27,F10.3)') "    Omega calcite       (~) = ", om_cal
 !  WRITE(*,'(A27,F10.3)') "    Omega aragonite     (~) = ", om_arg
-!  WRITE(*,'(A27,F10.3)') "    air sea flux(mmol/m2/d) = ", flux
+!  WRITE(*,'(A27,F10.3)') "    air sea flux(mmol/m2/s) = ", flux
 !  WRITE(*,*) " "
 
@@ -287,5 +290,5 @@
 !=======================================================================
 !
-      SUBROUTINE Air_sea_exchange( T, Wnd, pco2w, pco2a, henry, dcf, &
+      SUBROUTINE Air_sea_exchange( T, xkw, pco2w, pco2a, henry, dcf, &
       flux )
 !      
@@ -302,5 +305,6 @@
 !  pCO2a    partial pressure of CO2 in the atmosphere (usually external forcing).
 !  T        temperature (C)
-!  Wnd      wind speed, metres
+!  Wnd      wind speed, metres (DELETED)
+!  xkw      gas transfer velocity
 !  Henry    henry's constant
 !  density  the density of water for conversion between mmol/m3 and umol/kg
@@ -312,5 +316,5 @@
    IMPLICIT NONE
 
-      REAL(wp), INTENT( in )    :: T, wnd, pco2w, pco2a, henry, dcf ! INPUT PARAMETERS:
+      REAL(wp), INTENT( in )    :: T, xkw, pco2w, pco2a, henry, dcf ! INPUT PARAMETERS:
 !-----------------------------------------------------------------------
       REAL(wp), INTENT( inout ) :: flux                             ! OUTPUT Variables
@@ -320,5 +324,6 @@
 ! calculate the Schmidt number and unit conversions
           sc    = 2073.1-125.62*T+3.6276*T**2.0-0.0432190*T**3.0
-          fwind = (0.222d0 * wnd**2d0 + 0.333d0 * wnd)*(sc/660.d0)**(-0.5)
+!         fwind = (0.222d0 * wnd**2d0 + 0.333d0 * wnd)*(sc/660.d0)**(-0.5)
+          fwind = xkw * (sc/660.d0)**(-0.5)
           fwind = fwind*24.d0/100.d0   ! convert to m/day
 
@@ -326,4 +331,7 @@
 ! here it is rescaled to mmol/m2/d
           flux = fwind * henry * ( pco2a - pco2w ) * dcf
+
+! AXY (23/06/15): let's get it from /d to /s
+          flux = flux / ( 86400. )
 
   RETURN 
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 6639)
@@ -39,5 +39,5 @@
 !
    SUBROUTINE trc_dms_medusa( chn, chd, mld, xqsr, xdin,   &  !! inputs
-     &  dms_surf, dms_andr, dms_simo, dms_aran, dms_hall )    !! outputs
+     &  dms_andr, dms_simo, dms_aran, dms_hall )              !! outputs
 !      
 !=======================================================================
@@ -70,4 +70,9 @@
       !!                    published (and different from the above)
       !!
+      !! AXY (08/07/15): amend to remove Julien's original calculation
+      !!                 as this is now superfluous; the four schemes 
+      !!                 are calculated and one is chosen to be passed
+      !!                 to the atmosphere in trc_bio_medusa
+      !!
 !=======================================================================
 
@@ -79,5 +84,4 @@
       REAL(wp), INTENT( in )    :: xqsr                 !! surface irradiance        (W/m2)
       REAL(wp), INTENT( in )    :: xdin                 !! surface DIN               (mmol N/m3)
-      REAL(wp), INTENT( inout ) :: dms_surf             !! DMS surface concentration (mol/m3) 
       REAL(wp), INTENT( inout ) :: dms_andr             !! DMS surface concentration (mol/m3) 
       REAL(wp), INTENT( inout ) :: dms_simo             !! DMS surface concentration (mol/m3) 
@@ -89,73 +93,4 @@
       !! temporary variables
       REAL(wp) ::    fq1,fq2,fq3
-!
-!! IJT (30/03/13): DMS calc needs this
-!! Julien : in Simo & Dachs, GBC, 2002, DMS is derived from 
-!!          CHL/MLD ratio in mg/m4 (i.e. CHL is in mg/m3
-!!          MLD in m).
-!!          In MEDUSA, we already have CHL in mg/m3 for both
-!!          Diatoms and non-diatoms (zchn,zchd); and mld from
-!!          NEMO (hmld) in m.
-      CHL = 0.0
-!!
-!!            CHL = mask * TT(I,J,1,PHYTO_TRACER) &
-!!     &       * c2n_p * mw_carbon / CCHL_P(I,J,1,1)
-      CHL = chn+chd                                 !! mg/m3 
-!!
-!! ------------------------------------------------
-!!  Calculate the DMS concentration in nM (nanomol/litre)
-!!   from Simo & Dachs, GBC, 2002, modified to be positive-definite
-!!   for MLD>182.536m, using DMS=90./MLD (Aranami & Tsunogai, JGR, 2004)
-!!   Multiply by 1.0E-6 to convert nM to (mol/m3)
-!!       cmr = fm(i,1)*chl/mld(i)
-!!       IF (cmr .lt. 0.02) THEN
-!!         IF (mld(i) .le. 182.536) THEN
-!!           csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(-LOG(mld(i)) + 5.7)
-!!         ELSE
-!!           csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(90./mld(i))
-!!         ENDIF
-!!       ELSE
-!!         csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(55.8*cmr + 0.6)
-!!       ENDIF
-!!
-        cmr      = CHL / mld
-!       sw_dms   = 0.5 + SIGN( 0.5, cmr - 0.02 )
-!! Jpalm (11-08-2014)
-!! Explanation about the SIGN function :
-!! not easy to read, but maybe "more elegant and efficient")
-!! here for example: 
-!! sw_dms = 1 if cmr is greater than 0.02,
-!!          0 if cmr lower than 0.02
-!! then 
-!! if cmr < 0.02
-!!  dms_surf =  1.0e-6 * 90.0 / mld 
-!!       or  =  1.0e-6 * 5.7 - LOG(mld)
-!! and if cmr > 0.02
-!!  dms_surf = 1.0e-6 * ( 55.8 * cmr + 0.6 )
-!! what is equivalent to the IF loops formulations.
-!! difference is on the stresholds between mld = 182.536m
-!! (strange value...)
-!! and the Max function... that stay uncertain.
-!!
-!        dms_surf = 1.0e-6 * ( sw_dms *             &
-!     &  ( 55.8 * cmr + 0.6 ) + ( 1.0 - sw_dms ) *  &
-!     &  ( MAX( 90.0 / mld, 5.7 - LOG(mld) ) ) )
-!
-! AXY (12/01/15): the DMS equation donated by the UKMO does not match
-!                 that reported in Halloran et al. (2010); amend the
-!                 equations appropriately
-!
-        if (cmr .lt. 0.02) then
-           dms_surf = (-1.0 * log(mld)) + 5.7
-        else
-           dms_surf = (55.8 * cmr) + 0.6
-        endif
-!    
-        if (mld > 182.5) then
-           dms_surf = (90.0 / mld)
-        endif
-!     
-        dms_surf = 1.0e-6 * dms_surf
-
 ! 
 !=======================================================================
@@ -163,4 +98,8 @@
 ! AXY (13/03/15): per remarks above, the following calculations estimate
 !                 DMS using all of the schemes examined for UKESM1
+!
+      CHL = 0.0
+      CHL = chn+chd                                 !! mg/m3 
+      cmr = CHL / mld
 !
 ! AXY (13/03/15): Anderson et al. (2001)
@@ -180,5 +119,4 @@
 !
 ! AXY (13/03/15): Simo & Dachs (2002)
-        cmr = CHL / mld
         fq1 = (-1 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
@@ -191,5 +129,4 @@
 !           
 ! AXY (13/03/15): Aranami & Tsunogai (2004)
-        cmr = CHL / mld
         fq1 = 60.0 / mld
         fq2 = (55.8 * cmr) + 0.6
@@ -202,5 +139,4 @@
 !        
 ! AXY (13/03/15): Halloran et al. (2010)
-        cmr = CHL / mld
         fq1 = (-1 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
